
#ifndef __2021_I2C_H
#define __2021_I2C_H

#include "stm32f10x.h"

#define i2c_delay 10

#define  SDA_PIN    GPIO_Pin_7
#define  SDA_GPIO   GPIOB

#define  SCL_PIN    GPIO_Pin_6
#define  SCL_GPIO   GPIOB

#define  RST_PIN    GPIO_Pin_5
#define  RST_GPIO   GPIOB

//#define  SDA_L()	 GPIO_ResetBits(SDA_GPIO, SDA_PIN)
//#define  SDA_H()	 GPIO_SetBits(SDA_GPIO, SDA_PIN) 

//#define  SCL_L()	 GPIO_ResetBits(SCL_GPIO, SCL_PIN)
//#define  SCL_H()	 GPIO_SetBits(SCL_GPIO, SCL_PIN) 

//#define  RST_L()	 GPIO_ResetBits(RST_GPIO, RST_PIN)
//#define  RST_H()	 GPIO_SetBits(RST_GPIO, RST_PIN) 

#define  SDA_STAT()   GPIO_ReadInputDataBit(SDA_GPIO, SDA_PIN)  
#define  SCL_STAT()   GPIO_ReadInputDataBit(SCL_GPIO, SCL_PIN)  

#define   SDA_L()		 GPIOB->BRR=1<<7	 
#define   SDA_H()	 	 GPIOB->BSRR=1<<7

#define   SCL_L()		 GPIOB->BRR=1<<6 
#define   SCL_H()	 	 GPIOB->BSRR=1<<6

#define   RST_L()		 GPIOB->BRR=1<<5
#define   RST_H()	 	 GPIOB->BSRR=1<<5

//#define  SDA_STAT()   (GPIOB->IDR & GPIO_Pin_7)
//#define  SCL_STAT()   (GPIOB->IDR & GPIO_Pin_6)



void i2c_gpio_init(void);

void i2c_delay_times(u32 times);
void i2c_free(void);
void i2c_start(void);
void i2c_stop(void);
void i2c_write_data(u8 temp);
u8 i2c_read_data(void);
void i2c_ack(void);
void i2c_nack(void);
u8 i2c_waitack(void);

u8 text_i2c_address(u8 address);

//24c02
void write_eeprom(u8 address,u8 temp);
u8 read_eeprom(u8 address);

//ssd1306 oled 12864
void reset_oled_12864(void);
void init_oled_12864(void);
void clear_oled_12864(u8 colour);
void bmp_oled_12864(const u8 *table);
void front8_oled_12864(u8 x,u8 y,u8 data,u8 colour);
void front16_oled_12864(u8 x,u8 y,u8 data,u8 colour);
void front16_16_oled_12864(u8 x,u8 y,u8 data,u8 colour);
void front16_32_oled_12864(u8 x,u8 y,u8 data,u8 colour);

void clear_oled_buff(void);
void write_point_oled(u8 x,u8 y);	
void clear_point_oled(u8 x,u8 y);

//ina226
u16 read_ina226(u8 address);
void write_ina226(u8 address,u16 temp);
void init_ina226(void);
u8 read_back_init_ina226(void);//֤Ƿ

//CSC2313 OR TDA7313  i2c address 0x88
void write_csc2313_reg(void);
void csc2313_volume_control(u16 data_buff);
void csc2313_speaker_attenuators(u8 lf_data_buff,u8 rf_data_buff,u8 lr_data_buff,u8 rr_data_buff);
void csc2313_audio_switch(u8 input_sw,u8 gain_sw,u8 gain_value);
void csc2313_bass_and_treble(u8 bass_value,u8 treble_value);

//PCF8563  2021.8.1
void write_pcf8563(u8 address,u8 temp);
u8 read_pcf8563(u8 address);
void read_pcf8563_time(u8 *data);
void write_pcf8563_time(u8 *data);
#endif

