#include "stm32f10x.h"
#include "ADC1_DMA_INIT.h"

u16 AdcBuffer[10];

void adc1_gpio_init(void)
{	
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4;//ADC
	GPIO_InitStructure.GPIO_Mode =GPIO_Mode_AIN;		   //ģ  
	GPIO_Init(GPIOA, &GPIO_InitStructure);		

}

void adc1_init(void)
{
	ADC_InitTypeDef ADC_InitStructure; 
	DMA_InitTypeDef DMA_InitStructure;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE); //DMAʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 , ENABLE); 
		
	//dma config	
   /* DMA channel1 configuration */
	DMA_DeInit(DMA1_Channel1);
	DMA_InitStructure.DMA_PeripheralBaseAddr = 0x4001244C;//ַ ADC_DR Ĵĵַ
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)AdcBuffer;
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
	DMA_InitStructure.DMA_BufferSize = 5;
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;// ̶ַ
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;//ڴַ
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
	DMA_InitStructure.DMA_Mode = DMA_Mode_Circular;//DMA_Mode_Normal
	DMA_InitStructure.DMA_Priority = DMA_Priority_Medium;
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
	DMA_Init(DMA1_Channel1, &DMA_InitStructure);

   /* Enable DMA channel1 */
	DMA_Cmd(DMA1_Channel1,ENABLE);

	/* Resets ADC1 */ 
	ADC_DeInit(ADC1); 
	
	/* Configure ADCCLK such as ADCCLK = PCLK2/2 */ 
	RCC_ADCCLKConfig(RCC_PCLK2_Div8); 
	
	/* Enable the temperature sensor and vref internal channel */ 
//	ADC_TempSensorVrefintCmd(ENABLE); 
	
	/* Initialize the ADC1 according to the ADC_InitStructure members */ 

	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent ; //ģʽ
	ADC_InitStructure.ADC_ScanConvMode = ENABLE; 
	ADC_InitStructure.ADC_ContinuousConvMode = ENABLE; 
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None ; 
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right; 
	ADC_InitStructure.ADC_NbrOfChannel = 5; 
	ADC_Init(ADC1, &ADC_InitStructure); 
	
	ADC_RegularChannelConfig(ADC1, ADC_Channel_0, 1, ADC_SampleTime_239Cycles5 ); 
	ADC_RegularChannelConfig(ADC1, ADC_Channel_1, 2, ADC_SampleTime_239Cycles5 ); 
	ADC_RegularChannelConfig(ADC1, ADC_Channel_2, 3, ADC_SampleTime_239Cycles5 ); 
	ADC_RegularChannelConfig(ADC1, ADC_Channel_3, 4, ADC_SampleTime_239Cycles5 ); 
	ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 5, ADC_SampleTime_239Cycles5 ); 



	/* Enable ADC1 */ 
	ADC_Cmd(ADC1, ENABLE); 		
  	/* Enable ADC1 DMA transfer */ 
	ADC_DMACmd(ADC1, ENABLE); 
	
	/* Enable ADC1 reset calibaration register У׼*/   
	ADC_ResetCalibration(ADC1);
	/* Check the end of ADC1 reset calibration register */
	while(ADC_GetResetCalibrationStatus(ADC1));
	
	/* Start ADC1 calibaration */
	ADC_StartCalibration(ADC1);
	/* Check the end of ADC1 calibration */
	while(ADC_GetCalibrationStatus(ADC1));
	
	/* Start ADC1 Software Conversion */ 
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);	   

}

void Adc1_DMA_Init(void)
{
		adc1_gpio_init();
		adc1_init();
}



